unit Unit1;

{
Compacter une base de donne Access.
--
DEBOVE Benjamin
09/02/2004
--
On utilise JRO (Jet Replication Object) pour l'installer faire Projet | Importer une bibliothque de types...
Choisir "Microsoft Jet and Replication Objects 2.x Library (Version 2.x)".
Clicker sur le bouton Install, il y aura alors 2 icnes supplmentaires dans l'onglet ActiveX de
la barre des composants .
NB : Exemple ralis  partir du site "http://delphi.about.com/library/weekly/aa091801a.htm"
}
  
{------------------------------------------------------------------------------}
                                   INTERFACE
{------------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleServer, JRO_TLB, Buttons, ExtCtrls, ComCtrls, IdGlobal;

type
  TForm1 = class(TForm)
    OD_ChoixFichier: TOpenDialog;
    Button_Parcourir: TButton;
    BitButton_Compacter: TBitBtn;
    LblTxt_TailleFichierSource: TLabeledEdit;
    LblTxt_TailleFichierResultat: TLabeledEdit;
    LblTxt_Destination: TLabeledEdit;
    LblTxt_Source: TLabeledEdit;
    Lbl_KoSource: TLabel;
    Lbl_KoDestination: TLabel;
    StatusBar: TStatusBar;
    LblTxt_Password: TLabeledEdit;
    procedure Button_ParcourirClick(Sender: TObject);
    procedure BitButton_CompacterClick(Sender: TObject);
    procedure LblTxt_DestinationChange(Sender: TObject);
    procedure LblTxt_SourceChange(Sender: TObject);
  private
    procedure Compacter(Const P_FileNameSrc, P_FileNameDst, Password : string);
    procedure MAJTailleFichiers;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

Const
  RS_FileNotFound : string = 'Fichier "%s" introuvable.';
  RS_Terminated   : string = 'Compactage termin.';
  RS_QuestionSuppression : string = 'Un fichier "%s" existe dj. Voulez-vous l''craser ?';
  CST_Compacted   : string = '_Compact';
  CST_MDB         : string = '.mdb';
{------------------------------------------------------------------------------}
                                IMPLEMENTATION
{------------------------------------------------------------------------------}

{$R *.dfm}     

{------------------------COMPACTER-/-DEFRAGMENTER-CLICK------------------------}
procedure TForm1.BitButton_CompacterClick(Sender: TObject);
begin
  StatusBar.Panels[0].Text := '';
  if FileExists(LblTxt_Source.Text) then
  begin
    if FileExists(LblTxt_Destination.Text)
    then if MessageDlg(Format(RS_QuestionSuppression, [LblTxt_Destination.Text]), mtWarning, mbYesNoCancel,0) = mrYes
         then begin
                DeleteFile(LblTxt_Destination.Text);
                Compacter(LblTxt_Source.Text, LblTxt_Destination.Text, LblTxt_Password.Text);
              end
         else
    else Compacter(LblTxt_Source.Text, LblTxt_Destination.Text, LblTxt_Password.Text);
  end else Showmessage(Format(RS_FileNotFound,[LblTxt_Source.Text]));
end;
{---------------------------------PARCOURIR------------------------------------}
procedure TForm1.Button_ParcourirClick(Sender: TObject);
begin
  if OD_ChoixFichier.Execute then
  begin
    LblTxt_Source.Text := OD_ChoixFichier.FileName;
    LblTxt_Destination.Text   := ChangeFileExt(OD_ChoixFichier.FileName, CST_Compacted) + CST_MDB;
  end;
  MAJTailleFichiers;
end;
{---------------------------------COMPACTER------------------------------------}
procedure TForm1.Compacter(Const P_FileNameSrc, P_FileNameDst, Password : string);
var
  ConSrc  : WideString;
  ConDst : WideString;
  TmpJE  : TJetEngine;
const
  SProvider = 'Provider=Microsoft.Jet.OLEDB.4.0;'+
              'Data Source=';
  SPassword = ';Jet OLEDB:Database Password="';
begin
//Cration de l'objet JetEngine
  TmpJE  := TJetEngine.Create(self);
//Dfinition des paramtres SourceConnection et DstConnection
  ConSrc := SProvider + P_FileNameSrc + SPassword+Password+'"';
  ConDst := SProvider + P_FileNameDst + SPassword+Password+'"';
//Appel de la mthode compacter de l'objet JetEngine
  TmpJE.CompactDatabase(ConSrc,ConDst);
//Destruction de l'objet JetEngine
  FreeAndNil(TmpJE);
//Mise  jour de l'affichage
  StatusBar.Panels[0].Text := RS_Terminated;
  MAJTailleFichiers;
end;
{-----------------------------MAJ-TAILLE-FICHIER-------------------------------}
procedure TForm1.MAJTailleFichiers;
begin
  if FileExists(LblTxt_Source.Text)
  then LblTxt_TailleFichierSource.Text := floattostr(FileSizeByName(LblTxt_Source.Text)/1024)
  else LblTxt_TailleFichierSource.Text := '';
  if FileExists(LblTxt_Destination.Text)
  then LblTxt_TailleFichierResultat.Text := floattostr(FileSizeByName(LblTxt_Destination.Text)/1024)
  else LblTxt_TailleFichierResultat.Text := '';
end;
{------------------------------------------------------------------------------}
procedure TForm1.LblTxt_DestinationChange(Sender: TObject);
begin
  MAJTailleFichiers;
end;
{------------------------------------------------------------------------------}
procedure TForm1.LblTxt_SourceChange(Sender: TObject);
begin
  MAJTailleFichiers;
end;

end.
